#!/usr/bin/python
# 
# Copyright (C) 2009, Intel Corporation.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.  
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307 USA.
#
# Authors:
#              Hao, Chen <hao.h.chen@intel.com>
#

import sys
import os

sys.path.append("../../tetj/")
from tetj import *

def check_kernel_cfg_flags(cfg_flag, journal = None):   
    kernel_ver = (os.uname())[2]
    kernelcfg_moblin = '/lib/modules/' + kernel_ver + '/build/.config'
    kernelcfg_osv = '/boot/config-' + kernel_ver

    # Search kernel config file for specified config flag
    ret = TETJ_WARNING
    kernelcfg = ''
    if os.path.isfile(kernelcfg_moblin):
        kernelcfg = kernelcfg_moblin
    else:
        kernelcfg = kernelcfg_osv

    if kernelcfg == '':
        info = 'Kernel config file not found.'
    else:
        info = 'Search "%s" in %s\n' % (cfg_flag, kernelcfg)
        try: 
            data = open (kernelcfg, 'rb').read()
    	    # Do a quick search
	    pattern = cfg_flag
	    if data.find(pattern) != -1:
	        data = data.split('\n')
	        i = 0

	        # Now do line-by-line check
	        for line in data:
		    i += 1
		    if line.find(pattern) != -1:
		        info +=  'Found in line %s: %s' % (i, line)
                        ret = TETJ_PASS
                        break
        except (OSError, IOError), (errno, strerror):
	    info += "error(%s): %s" % (errno, strerror)

    if TETJ_WARNING == ret:
	info += "WARNING: can't find \"%s\", \"%s\" is recommended to be supported"%(cfg_flag,cfg_flag)
    print info
    if journal != None:
        journal.testcase_info(0, 0, 0, info)

    return ret
   
 
if __name__ == '__main__':
    check_kernel_cfg_flags(sys.argv[1])
